#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>

int main(int argc, char **argv)
{
    FILE *f;
    uint32_t size;
    uint8_t *buf, *end, *ptr;
    char name[4096], *fn;

    /* read in archive */
    if(argc < 2) {
        printf("%s <000 archive>\r\n", argv[0]);
        return 1;
    }
    if(!(f = fopen(argv[1], "rb"))) {
        fprintf(stderr, "unable to open %s\r\n", argv[1]);
        return 1;
    }
    fseek(f, 0, SEEK_END);
    size = ftell(f);
    fseek(f, 0, SEEK_SET);
    if(!(buf = malloc(size))) {
        fclose(f);
        fprintf(stderr, "unable to allocate memory\r\n");
        return 1;
    }
    fread(buf, 1, size, f);
    fclose(f);
    if(memcmp(buf, "FFIJ", 4)) {
        free(buf);
        fprintf(stderr, "does not seem to be a 000 archive\r\n");
        return 1;
    }

    /* create output directory */
    strcpy(name, argv[1]);
    strcat(name, ".extracted");
#ifdef __WIN32__
    mkdir(name);
#else
    mkdir(name, 0777);
#endif
    fn = name + strlen(name);

    /* iterate on chunks and save them one by one */
    for(ptr = buf + 8, end = buf + size; ptr + 8 < end; ptr += size) {
        sprintf(fn, "/%08x_%c%c%c%c.bin", (uintptr_t)ptr - (uintptr_t)buf, ptr[0], ptr[1], ptr[2], ptr[3]);
        size = *((uint32_t*)(ptr + 4)) + 8;
        if((f = fopen(name, "wb"))) {
            if(!memcmp(ptr, "CSER", 4)) {
                size -= 8;
                fwrite(ptr + 24, 1, size - 24, f);
            } else
                fwrite(ptr, 1, size, f);
            fclose(f);
        }
    }
    free(buf);
    return 0;
}
